import { VueLoaderPlugin } from 'vue-loader';
//
export default () => {
    return {
        name: '@empjs/plugin-vue2',
        async rsConfig(store) {
            //
            const { importResolve } = store;
            //
            store.merge({ experiments: { css: false } });
            // console.log(store.chain)
            // store.chain.store('experiments').add({css:false})
            const { chain } = store;
            // chain.resolve.alias.set('vue', '@vue/runtime-dom')
            chain.resolve.alias.set('vue$', 'vue/dist/vue.runtime.esm.js');
            chain.plugin('vue-loader-plugin').use(VueLoaderPlugin, []);
            chain.module.rule('javascript').uses.clear().end();
            chain.module.rule('typescript').uses.clear().end();
            // chain.module.rules.delete('javascript').end()
            // chain.module.rules.delete('typescript').end()
            //
            chain.module
                .rule('vue-loader')
                .test(/\.vue$/)
                .use('vue-loader')
                .loader(importResolve('vue-loader'))
                .options({
                compilerOptions: {
                    preserveWhitespace: false,
                },
                experimentalInlineMatchResource: true,
            })
                .end()
                .use('vue-svg-inline-loader')
                .loader(importResolve('vue-svg-inline-loader'))
                .end();
            //
            chain.module
                .rule('vue-jsx')
                .test(/\.(js|jsx)$/)
                .use('babel-loader')
                .loader(importResolve('babel-loader'))
                .options({
                presets: [
                    [
                        importResolve('@vue/babel-preset-jsx'),
                        {
                            compositionAPI: true,
                            injectH: true,
                            vModel: false,
                        },
                    ],
                ],
            })
                .end();
            // css
            chain.module
                .rule('css')
                .uses.clear()
                .end()
                .use('vue-style-loader')
                .loader(importResolve('vue-style-loader'))
                .end()
                .use('css-loader')
                .loader(importResolve('css-loader'))
                .end();
            // less
            chain.module
                .rule('less')
                .uses.clear()
                .end()
                .use('vue-style-loader')
                .loader(importResolve('vue-style-loader'))
                .end()
                .use('css-loader')
                .loader(importResolve('css-loader'))
                .end()
                .use('less-loader')
                .loader(importResolve('less-loader'))
                .end();
            // sass
            chain.module
                .rule('sass')
                .uses.clear()
                .end()
                .use('vue-style-loader')
                .loader(importResolve('vue-style-loader'))
                .end()
                .use('css-loader')
                .loader(importResolve('css-loader'))
                .end()
                .use('sass-loader')
                .loader(importResolve('sass-loader'))
                .end();
            //
            const type = 'javascript/auto';
            store.chain.merge({
                module: {
                    rule: {
                        // scripts: {
                        //   test: /\.(js|tsx?)$/,
                        // },
                        css: {
                            type,
                        },
                        less: {
                            type,
                        },
                        sass: {
                            type,
                        },
                        svg: {
                            type: 'asset/resource',
                        },
                    },
                },
            });
            //
            //.use('vue-svg-loader').loader(importResolve('vue-svg-loader')).end()
        },
    };
};
